<h1>ArrayMapper</h1>
<h4>Array mapper is a tool for developers, who wants to have clear image of an array that they're working with.</h4>
<h5>You can install ArrayMapper by npm: <code>npm install arraymapper</code></h5>

<h3>List of upcoming features in version 0.0.3:</h3>
<ul>
   <li>Remove values from an array - Updated: 30/09/2017</li>
</ul>

<h3>List of upcoming features in version 0.0.4:</h3>
<h4>The version 0.0.4 will be available 21st of October</h4>
<ul>
   <li>Add UI JSON objects explorer</li>
   <li>Modify JSON objects</li>
   <li>Add possibility to work with one dimensional array</li>
   <li>Change the look of an application from UI perspective</li>
   <li>I will fix existing bugs</li>
</ul>

<h3>1. Description:</h3>
<p>An ArrayMapper is a small tool for Front End Developers, that provides possibility to take a look at your array without using <code>console.log()</code></p>
<p><strong>As you can see below, it has graphic interface where you can see:</strong></p>
<img src="https://res.cloudinary.com/dvzfz81yf/image/upload/v1505072850/array-mapper-screenshoot-01_zuqsk9.jpg" alt="image">
<ul>
  <li>Index and value of selected element. If you hover on one of the elements, you can see index and value as well.</li>
  <li>Check how many elements is between two selected elements.</li>
  <li>See approximate memory usage of your array</li>
  <li>See length of your array.</li>
  <li>You can select index from an array and see what is inside by just typing index number in the panel section.</li>
  <li>Find specific value in an array by just typing value in the panel section, that you want to find.</li>
  <li>You can simulate, how your array is going to look like by pushing values into it and seeing live changes.</li>
  <li>In the structure section, you can see whole structure of your array</li>
  <li>You can also see, what types your array is full of. Simply saying, it shows you how many strings, numbers or booleans you've got in your array.</li>
   <li>You can simulate removing values from an array</li>
</ul>
<h4>Do you like it? It's just small amount of function that ArrayMapper is having. More functions is coming to it really soon.</h4>
<h3>2. Documentation</h3>
<h4>Step 1: Add your array into the app</h4>
<p>Open app.js and to the function  
  
```JavaScript 
  generate.setArray([]) 
```  
append your array. It should look like on below screenshot:</p>
<img src="https://res.cloudinary.com/dvzfz81yf/image/upload/v1505073692/array-mapper-screenshoot-02_vckljk.jpg" alt="image">

<h4>Step 2: Webpack</h4>
<p>ArrayMapper has included Webpack as a dev-dependency but if for some reason you don't have it, install newest webpack.
<code>npm install webpack</code></p>
<p>Once you've got webpack installed, you can open command line and type: <code>webpack app.js app.bundle.js</code></p>
<p>After that, just go to the app folder, run index.html and it's working. No localhost.</p>

<h3>3. Contribution</h3>
<p>If you want to contribute, go ahead. Fork the repo and contribute.<br>
If you have new ideas, how to improve ArrayMapper or found a bug. Post everyting in the "Issues" tab.</p>

<h4>If you like ArrayMapper, give it a star and share it, please. Thank you!</h4>
