/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 6);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__array_mapper_events__ = __webpack_require__(3);


const generate = (() => {
    const box = document.querySelector('.js-box');
    let array, boxCells = [];
    return {
        setArray: (arr) => {
            array = arr;
            generate.arrayMap();
        },
        setBoxCells: () => {
            boxCells = Array.from(box.children);
        },
        getArray: () => array,
        getBoxCells: () => boxCells,
        arrayMap: () => { // Generates array-map from provided array.
            generate.getArray().map((val, indx) => {
                val.map((val, indx) => {
                    const cell = document.createElement('div');
                    cell.setAttribute('arr-value', val);
                    cell.classList.add('js-cell');
                    box.appendChild(cell);
                });
            });

            boxCells = Array.from(box.children);
        }
    }
})();
/* harmony export (immutable) */ __webpack_exports__["a"] = generate;


/***/ }),
/* 1 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__array_mapper_append_dom__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__array_mapper_generate_map__ = __webpack_require__(0);



const show = (() => {
    const countSelectedArr = [];
    let position = [];
    let count = 0;
    return {
        flushAll: () => {
            position.length = 0;
            countSelectedArr.length = 0; 
            count = 0;
        },
        attribute: (val) => {
            return val.attributes.getNamedItem('arr-value').value;
        },
        distance: (indx, val) => {
            count += 1;
            if (count >= 3) {
                return false;
            } else {
                val.classList.add('selected');
                if (position[0]) {
                    position[1] = indx;
                    __WEBPACK_IMPORTED_MODULE_0__array_mapper_append_dom__["a" /* appendDOM */].distance(position)
                } else {
                    position[0] = indx;
                    __WEBPACK_IMPORTED_MODULE_0__array_mapper_append_dom__["a" /* appendDOM */].distance(position);
                }
            }
        },
        sumOfSelected: (value) => {
            const attrValue = Number(show.attribute(value));
            countSelectedArr.push(attrValue);
            if (countSelectedArr.length >= 2) {
                const sum = countSelectedArr.reduce((x, y) => x + y);
                __WEBPACK_IMPORTED_MODULE_0__array_mapper_append_dom__["a" /* appendDOM */].sumOfSelected(sum);
            }
        },
        arrLength: () => {
            return __WEBPACK_IMPORTED_MODULE_1__array_mapper_generate_map__["a" /* generate */].getArray().length;
        },
        memoryAmount: () => {
            const emptyArray = 32;
            const numberByte = 9.7;
            let result;
            result = __WEBPACK_IMPORTED_MODULE_1__array_mapper_generate_map__["a" /* generate */].getArray().map((val, indx) => val.length);
            result = result.reduce((x, y) => x + y);
            result = (emptyArray + (numberByte * result)).toPrecision(3);
            
            return `${result} bytes`;
        }
    }
})();
/* harmony export (immutable) */ __webpack_exports__["a"] = show;


/***/ }),
/* 2 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__array_mapper_show__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__array_mapper_generate_map__ = __webpack_require__(0);



const appendDOM = (() => {
    const position1 = document.querySelector('.js-data-index-1');
    const position2 = document.querySelector('.js-data-index-2');
    const distance = document.querySelector('.js-data-distance');
    const arrayLength = document.querySelector('.js-data-array-length');
    const memoryArray = document.querySelector('.js-data-memory-array');
    const sumOfSelected = document.querySelector('.js-data-sum');
    
    let min,  max;
    return {
        distance: (value) => {
            position1.innerHTML = value[0];
            position2.innerHTML = value[1] || 0;

            if (value[0] && value[1]) {
                min = Math.min(...value);
                max = Math.max(...value);
                distance.innerHTML = max - min;
            } else {
                return 0;
            }
        },
        resetAll: () => {
            position1.innerHTML = 0;
            position2.innerHTML = 0;
            distance.innerHTML = 0;
            sumOfSelected.innerHTML = 0;
        },
        arrLength: () => {
            arrayLength.innerHTML = __WEBPACK_IMPORTED_MODULE_0__array_mapper_show__["a" /* show */].arrLength() || 0;
        },
        memoryAmount: () => {
            memoryArray.innerHTML = __WEBPACK_IMPORTED_MODULE_0__array_mapper_show__["a" /* show */].memoryAmount();
        },
        arrayStructure: (selector) => {
            const arr = __WEBPACK_IMPORTED_MODULE_1__array_mapper_generate_map__["a" /* generate */].getArray();
            const structure = JSON.stringify(arr);
            selector.innerHTML = structure.split('],').join(']<br>');
        },
        sumOfSelected: (sum) => {
            sumOfSelected.textContent = sum;
        },
        removeCell: (value) => {
            console.log(value);
            const box = document.querySelector('.js-box');
            const cells = document.querySelectorAll('.js-cell');
            const valueIndx = Array.from(cells, (val, indx) => {
                let cellIndx = indx;
               if (Number(value) === Number(val.attributes[0].value)) {
                   box.removeChild(cells[cellIndx]);
               }
            });
        }
    }
})();
/* harmony export (immutable) */ __webpack_exports__["a"] = appendDOM;




/***/ }),
/* 3 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__array_mapper_get__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__array_mapper_show__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__array_mapper_generate_map__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__array_mapper_reset__ = __webpack_require__(7);





const events = (() => {
    return {
        showData: () => {
            __WEBPACK_IMPORTED_MODULE_2__array_mapper_generate_map__["a" /* generate */].getBoxCells().map((val, indx) => {
                val.addEventListener('mouseenter', () => {
                    val.innerHTML = __WEBPACK_IMPORTED_MODULE_0__array_mapper_get__["a" /* get */].template(indx, val);
                });

                val.addEventListener('mouseleave', () => {
                    if (!val.classList.contains('selected')) {
                        val.innerHTML = '';
                    }
                });
            });
        },
        selectBoxCell: () => {
            __WEBPACK_IMPORTED_MODULE_2__array_mapper_generate_map__["a" /* generate */].getBoxCells().map((val, indx) => {
                val.addEventListener('click', () => {
                    val.innerHTML = __WEBPACK_IMPORTED_MODULE_0__array_mapper_get__["a" /* get */].template(indx, val);
                    __WEBPACK_IMPORTED_MODULE_1__array_mapper_show__["a" /* show */].distance(indx, val);
                    __WEBPACK_IMPORTED_MODULE_1__array_mapper_show__["a" /* show */].sumOfSelected(val);
                });
            });
        },
        resetSelected: () => {
            const resetBtn = document.querySelector('.js-reset-selected');
            __WEBPACK_IMPORTED_MODULE_2__array_mapper_generate_map__["a" /* generate */].getBoxCells().map((val, indx) => {
                resetBtn.addEventListener('click', () => __WEBPACK_IMPORTED_MODULE_3__array_mapper_reset__["a" /* reset */].selected(val));
            });
        }
    }
})();
/* harmony export (immutable) */ __webpack_exports__["a"] = events;


/***/ }),
/* 4 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__array_mapper_show__ = __webpack_require__(1);


const get = (() => {
    return {
        template: (indx, val) => {
            return `I: ${indx}<br>V: ${__WEBPACK_IMPORTED_MODULE_0__array_mapper_show__["a" /* show */].attribute(val)}`
        }
    }
})();
/* harmony export (immutable) */ __webpack_exports__["a"] = get;


/***/ }),
/* 5 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__array_mapper_append_dom__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__array_mapper_generate_map__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__array_mapper_panel__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__array_mapper_structure__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__array_mapper_events__ = __webpack_require__(3);






const attachAppendDOM = () => {
    __WEBPACK_IMPORTED_MODULE_0__array_mapper_append_dom__["a" /* appendDOM */].arrLength();
    __WEBPACK_IMPORTED_MODULE_0__array_mapper_append_dom__["a" /* appendDOM */].memoryAmount();
};
/* unused harmony export attachAppendDOM */


const attachPanel = (() => {
    return {
        once: () => {
            __WEBPACK_IMPORTED_MODULE_2__array_mapper_panel__["a" /* panel */].pushValue();
        },
        more: () => {
            __WEBPACK_IMPORTED_MODULE_2__array_mapper_panel__["a" /* panel */].findValue();
            __WEBPACK_IMPORTED_MODULE_2__array_mapper_panel__["a" /* panel */].selectIndex();
        },
        all: () => {
            __WEBPACK_IMPORTED_MODULE_2__array_mapper_panel__["a" /* panel */].pushValue();
            __WEBPACK_IMPORTED_MODULE_2__array_mapper_panel__["a" /* panel */].removeValue();
            __WEBPACK_IMPORTED_MODULE_2__array_mapper_panel__["a" /* panel */].findValue();
            __WEBPACK_IMPORTED_MODULE_2__array_mapper_panel__["a" /* panel */].selectIndex();
        }
    }
})();
/* unused harmony export attachPanel */


const attachStructure = () => {
    __WEBPACK_IMPORTED_MODULE_3__array_mapper_structure__["a" /* structure */].arrayStructure();
    __WEBPACK_IMPORTED_MODULE_3__array_mapper_structure__["a" /* structure */].arrayDiagram();
};
/* unused harmony export attachStructure */


const attachEvents = () => {
    __WEBPACK_IMPORTED_MODULE_4__array_mapper_events__["a" /* events */].showData();
    __WEBPACK_IMPORTED_MODULE_4__array_mapper_events__["a" /* events */].selectBoxCell();
    __WEBPACK_IMPORTED_MODULE_4__array_mapper_events__["a" /* events */].resetSelected();
};
/* unused harmony export attachEvents */


const refreshNewValue = (value) => {
    const box = document.querySelector('.js-box');
    const cell = document.createElement('div');
    cell.setAttribute('arr-value', value);
    cell.classList.add('js-cell');
    box.appendChild(cell);
    __WEBPACK_IMPORTED_MODULE_1__array_mapper_generate_map__["a" /* generate */].setBoxCells();

    refreshView();
}
/* harmony export (immutable) */ __webpack_exports__["a"] = refreshNewValue;


const refreshRemovedValue = (value) => {
    __WEBPACK_IMPORTED_MODULE_0__array_mapper_append_dom__["a" /* appendDOM */].removeCell(value);
    refreshView();
}
/* harmony export (immutable) */ __webpack_exports__["b"] = refreshRemovedValue;



const refreshView = () => {
    attachAppendDOM();
    attachPanel.more();
    attachStructure();
}
/* unused harmony export refreshView */


window.onload = () => {
    attachEvents();
    attachAppendDOM();
    attachPanel.all();
    attachStructure();
}

/***/ }),
/* 6 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__src_js_array_mapper_generate_map__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__src_js_array_mapper_core__ = __webpack_require__(5);




// Initial function. As a first and only argument provide an array. The array can contain numbers, strings and booleans.
__WEBPACK_IMPORTED_MODULE_0__src_js_array_mapper_generate_map__["a" /* generate */].setArray([
    [0, 21, 30, 40, 1, 2, 1],
    [567, 89, 11, 23, 45, 6],
    [567, 89, 11, 23, 45, 6],
    [0, 21, 30, 40, 1, 2, 1],
    [23, 1, 0, 6, 12, 46]
]);


/***/ }),
/* 7 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__array_mapper_show__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__array_mapper_append_dom__ = __webpack_require__(2);



const reset = (() => {
    return {
        selected: (val) => {
            if (val.classList.contains('selected')) {
                val.classList.remove('selected');
                val.innerHTML = '';
                __WEBPACK_IMPORTED_MODULE_0__array_mapper_show__["a" /* show */].flushAll();
                __WEBPACK_IMPORTED_MODULE_1__array_mapper_append_dom__["a" /* appendDOM */].resetAll();
            }
        }
    }
})();
/* harmony export (immutable) */ __webpack_exports__["a"] = reset;


/***/ }),
/* 8 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__array_mapper_get__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__array_mapper_generate_map__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__array_mapper_show__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__array_mapper_core__ = __webpack_require__(5);





const panel = (() => {
    const selectIndexBtn = document.querySelector('.js-select-index-btn');
    const selectIndexInput = document.querySelector('.js-select-index-input');
    const findValueBtn = document.querySelector('.js-find-value-btn');
    const inputFindValue = document.querySelector('.js-find-value-input');
    const pushValueBtn = document.querySelector('.js-push-value-btn');
    const pushValueInput = document.querySelector('.js-push-value-input');
    const removeValueInput = document.querySelector('.js-remove-value-input');
    const removeValueBtn = document.querySelector('.js-remove-value-btn');

    return {
        selectIndex: () => {
            const showIndex = () => {
                __WEBPACK_IMPORTED_MODULE_1__array_mapper_generate_map__["a" /* generate */].getBoxCells().map((val, indx) => {
                    if (val.classList.contains('selected')) {
                        val.classList.remove('selected');
                        val.innerHTML = '';
                    }
    
                    if (indx === Number(selectIndexInput.value)) {
                        val.classList.add('selected');
                        val.innerHTML = __WEBPACK_IMPORTED_MODULE_0__array_mapper_get__["a" /* get */].template(indx, val);
                    }
                });
            };
    
            selectIndexBtn.addEventListener('click', showIndex);
        },
        findValue: () => {
            findValueBtn.addEventListener('click', () => {
                __WEBPACK_IMPORTED_MODULE_1__array_mapper_generate_map__["a" /* generate */].getBoxCells().map((val, indx) => {
                    if (val.classList.contains('selected')) {
                        val.classList.remove('selected');
                        val.innerHTML = '';
                    }
                    if (__WEBPACK_IMPORTED_MODULE_2__array_mapper_show__["a" /* show */].attribute(val) === inputFindValue.value) {
                        val.classList.add('selected');
                        val.innerHTML = __WEBPACK_IMPORTED_MODULE_0__array_mapper_get__["a" /* get */].template(indx, val);
                    }
                });
            });
        },
        pushValue: () => {
            pushValueBtn.addEventListener('click', () => {
                const pushValue = Number(pushValueInput.value);
                const arr = __WEBPACK_IMPORTED_MODULE_1__array_mapper_generate_map__["a" /* generate */].getArray();
                const lastArray = arr[arr.length -1].length;
                const arr1 = [];
                
                if (lastArray >= 7) {
                    arr1.push(pushValue);
                    arr.push(arr1);
                } else {
                    arr[arr.length -1].push(pushValue);
                }

                Object(__WEBPACK_IMPORTED_MODULE_3__array_mapper_core__["a" /* refreshNewValue */])(pushValue);
            });
        },
        removeValue: () => {
            removeValueBtn.addEventListener('click', () => {
                const removedValue = Number(removeValueInput.value);
                const arr = __WEBPACK_IMPORTED_MODULE_1__array_mapper_generate_map__["a" /* generate */].getArray();
                const findRemovedValue = element => element === removedValue;
                const result = arr.map((val, indx) => {
                    const values = val.findIndex(findRemovedValue);
                    if (values !== (-1)) {
                        let valueToRemove = arr[indx].splice(values, 1);
                        Object(__WEBPACK_IMPORTED_MODULE_3__array_mapper_core__["b" /* refreshRemovedValue */])(valueToRemove);
                    }
                });
            });
        }
    }
})();
/* harmony export (immutable) */ __webpack_exports__["a"] = panel;


/***/ }),
/* 9 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__array_mapper_append_dom__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__array_mapper_generate_map__ = __webpack_require__(0);



const structure = (() => {
    const arrayStructure = document.querySelector('.js-structure-array');
    const numbersSpan = document.querySelector('.js-stat-numbers');
    const stringSpan = document.querySelector('.js-stat-strings');
    const booleanSpan = document.querySelector('.js-stat-booleans');
    return {
        arrayStructure: () => {
            __WEBPACK_IMPORTED_MODULE_0__array_mapper_append_dom__["a" /* appendDOM */].arrayStructure(arrayStructure);
        },
        arrayDiagram: () => {
            let numbers = 0, strings = 0, booleans = 0;
            __WEBPACK_IMPORTED_MODULE_1__array_mapper_generate_map__["a" /* generate */].getArray().map((val, indx) => {
                val.map((val, indx) => {
                    typeof val === "number" ? numbers += 1 : false;
                    typeof val === "string" ? strings += 1 : false;
                    typeof val === "boolean" ? booleans += 1 : false;
                });
            });
    
            numbersSpan.style.width = numbers;
            numbersSpan.textContent = numbers;
    
            stringSpan.style.width = strings;
            stringSpan.textContent = strings;
    
            booleanSpan.style.width = booleans;
            booleanSpan.textContent = booleans;
        }
    }
})();
/* harmony export (immutable) */ __webpack_exports__["a"] = structure;


/***/ })
/******/ ]);