import { attachEvents } from './array-mapper.events';

export const generate = (() => {
    const box = document.querySelector('.js-box');
    let array, boxCells = [];
    return {
        setArray: (arr) => {
            array = arr;
            generate.arrayMap();
        },
        setBoxCells: () => {
            boxCells = Array.from(box.children);
        },
        getArray: () => array,
        getBoxCells: () => boxCells,
        arrayMap: () => { // Generates array-map from provided array.
            generate.getArray().map((val, indx) => {
                val.map((val, indx) => {
                    const cell = document.createElement('div');
                    cell.setAttribute('arr-value', val);
                    cell.classList.add('js-cell');
                    box.appendChild(cell);
                });
            });

            boxCells = Array.from(box.children);
        }
    }
})();