import { show } from './array-mapper.show';
import { appendDOM } from './array-mapper.dom';

export const reset = (() => {
    return {
        selected: (val) => {
            if (val.classList.contains('selected')) {
                val.classList.remove('selected');
                val.innerHTML = '';
                show.flushAll();
                appendDOM.resetAll();
            }
        }
    }
})();