import { appendDOM } from './array-mapper.dom';
import { generate } from './array-mapper.generate.map';

export const structure = (() => {
    const arrayStructure = document.querySelector('.js-structure-array');
    const numbersSpan = document.querySelector('.js-stat-numbers');
    const stringSpan = document.querySelector('.js-stat-strings');
    const booleanSpan = document.querySelector('.js-stat-booleans');
    return {
        arrayStructure: () => {
            appendDOM.arrayStructure(arrayStructure);
        },
        arrayDiagram: () => {
            let numbers = 0, strings = 0, booleans = 0;
            generate.getArray().map((val, indx) => {
                val.map((val, indx) => {
                    typeof val === "number" ? numbers += 1 : false;
                    typeof val === "string" ? strings += 1 : false;
                    typeof val === "boolean" ? booleans += 1 : false;
                });
            });
    
            numbersSpan.style.width = numbers;
            numbersSpan.textContent = numbers;
    
            stringSpan.style.width = strings;
            stringSpan.textContent = strings;
    
            booleanSpan.style.width = booleans;
            booleanSpan.textContent = booleans;
        }
    }
})();